> For the complete documentation index, see [llms.txt](https://api-docs.devhub.com/llms.txt). Markdown versions of documentation pages are available by appending `.md` to page URLs; this page is available as [Markdown](https://api-docs.devhub.com/advanced/projects.md).

# Projects

Note: this API is in beta currently and is subject to change in the future.

## Datasource

### Sync Datasource

This endpoint is used to pass a payload of key/values to the datasource. The fields passed within payload are based on your Datasource configuration.

```
POST /api/v2/projects/datasources/12345/sync/
```

#### Data payload example

```javascript
{
    "payload": {
        "Site Title": "New Site",
        "URL": "www.example.com"
    }
}
```

### Response

If the sync is successful, you will receive a 202 status response that will contain information about the objects that were created or modified.

```javascript
{
    "objects": [
        {
            "obj_type": "Business",
            "method": "update",
            "data": {
                ...The full Business detail will be returned here
            },
            "resource_uri": "/api/v2/businesses/12345"
        },
        {
            "obj_type": "Site",
            "method": "create".,
            "data": {
                ...The full Site detail will be returned here
            },
            "resource_uri": "/api/v2/sites/123456"
        }
    ]
}
```

If there are errors with the sync, you will receive a 400 status response.

If the error is general (configuration errors, or bad payload data) you will receive a `ErrorLog` type.

```javascript
{
    "__all__": [
        {
            "type": "ErrorLog",
            "error": "KeyError: u'Site Title'"
        }
    ]
}
```

If the error is related to validation issues with a particular object API, you will receive a `APIErrorLog` type with more structured information.

```javascript
{
    "__all__": [
        {
            "type": "APIErrorLog",
            "error": {
                "formatted_domain": ["Invalid domain: notvalid"]
            }
        }
    ]
}
```

##


---

# Agent Instructions
This documentation is published with GitBook. GitBook is the documentation platform designed so that both humans and AI agents can read, navigate, and reason over technical content effectively. Learn more at gitbook.com.

## Querying This Documentation
If you need additional information that is not directly available in this page, you can query the documentation dynamically by asking a question.

Perform an HTTP GET request on the current page URL with the `ask` query parameter, and the optional `goal` query parameter:

```
GET https://api-docs.devhub.com/advanced/projects.md?ask=<question>&goal=<endgoal>
```

`ask` is the immediate question: it should be specific, self-contained, and written in natural language.
`goal` is optional and describes the broader end goal you are ultimately trying to accomplish on behalf of the user. GitBook uses it to tailor the answer towards what is most useful for that goal.

The response will contain a direct answer to the question and relevant excerpts and sources from the documentation.

Use this mechanism when the answer is not explicitly present in the current page, you need clarification or additional context, or you want to retrieve related documentation sections.
